/*
 * Copyright 2011 Vaadin Ltd.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.vaadin.server.widgetsetutils;

import com.vaadin.client.ServerConnector;
import com.vaadin.shared.ui.Connect.LoadStyle;

/**
 * WidgetMap generator that builds a widgetset that optimizes the transferred
 * data. Widgets are loaded only when used if the widgetset is built with this
 * generator.
 * 
 * @see WidgetMapGenerator
 * 
 */
public class LazyWidgetMapGenerator extends WidgetMapGenerator {
    @Override
    protected LoadStyle getLoadStyle(Class<? extends ServerConnector> connector) {
        return LoadStyle.LAZY;
    }

}
