/*
 * Copyright 2011 Vaadin Ltd.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.vaadin.sass.tree.controldirective;

import java.util.ArrayList;
import java.util.List;

import com.vaadin.sass.tree.Node;

public class EachDefNode extends Node implements ControlDefNode {
    private static final long serialVersionUID = 7943948981204906221L;

    private String var;
    private ArrayList<String> list;

    public EachDefNode(String var, ArrayList<String> list) {
        super();
        this.var = var;
        this.list = list;
    }

    public List<String> getVariables() {
        return list;
    }

    public String getVariableName() {
        return var;
    }

    @Override
    public String toString() {
        return "Each Definition Node: {variable : " + var + ", "
                + "children : " + list.size() + "}";
    }
}
